unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ComCtrls, MoteurP4, Grids;

type
  TFMain = class(TForm)
    PanelPlateau: TPanel;
    Timer: TTimer;
    PanelGeneral: TPanel;
    ButtonNouvellePartie: TButton;
    LabelJoueur1: TLabel;
    EditJoueur1: TEdit;
    EditJoueur2: TEdit;
    LabelJoueur2: TLabel;
    StringGrid: TStringGrid;
    Label1: TLabel;
    Label2: TLabel;
    // FORM
    procedure FormShow(Sender: TObject);
    // INTERFACE
    procedure ButtonNouvellePartieClick(Sender: TObject);
    procedure EditJoueur1KeyUp(Sender: TObject; var Key: Word;  Shift: TShiftState);
    // INTERACTION GRAPHIQUE
    procedure TimerTimer(Sender: TObject);
    procedure StringGridMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure StringGridMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  protected
    Plateau: TPlateau; // Plateau du jeu
    DDernierLache: TDateTime; // Date dernier lach, pour viter le multi-lach en cas de double-clic
  end;

var
  FMain: TFMain;

implementation

{$R *.dfm}

{ ============================================================================
  FORM
  ============================================================================ }
procedure TFMain.FormShow(Sender: TObject);
begin
     Timer.Enabled := False;
     Plateau := TPlateau.Create( PanelPlateau, StringGrid );
end;

{ ============================================================================
  INTERFACE
  ============================================================================ }
procedure TFMain.ButtonNouvellePartieClick(Sender: TObject);
begin
     Timer.Enabled := True;
     Randomize;
     Plateau.NouveauJeu( EditJoueur1.Text, EditJoueur2.Text, Random( 2 ) + 1 );
end;

// Affectation nom du joueur
procedure TFMain.EditJoueur1KeyUp(Sender: TObject; var Key: Word;  Shift: TShiftState);
begin
     if Assigned( Plateau ) then
       if Sender = EditJoueur1
         then Plateau.Joueur[ 1 ].SetNom( TEdit( Sender ).Text )
         else Plateau.Joueur[ 2 ].SetNom( TEdit( Sender ).Text )
end;

{ ============================================================================
  INTERACTIONS GRAPHIQUES
  ============================================================================ }

// Clignotement du jeton
procedure TFMain.TimerTimer(Sender: TObject);
begin
     //  Arret du timer si pas en cours de jeu
     if not Assigned( Plateau ) or ( Plateau.IJoueur = 0 ) then
       begin
       Timer.Enabled := False;
       Exit;
       end;
     // si Sender = nil -> effacement forc
     if ( Plateau.IJoueur <> 0 ) and (Timer.Tag = 0 ) and  Assigned( Sender ) then
         begin
         Plateau.PionAfficher( Plateau.IJoueur, Point( Plateau.ICurseur, -1 ) );
         Timer.Tag := 1;
         Timer.Interval := 1000;
         end
       else
         begin
         Plateau.PionAfficher( 0, Point( Plateau.ICurseur, -1 ) );
         Timer.Tag := 0;
         Timer.Interval := 250;
         end;
end;

// Dplacement du curseur
procedure TFMain.StringGridMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var
   INewCurseur: Integer;
begin
     if Plateau.IJoueur = 0 then Exit;
     // nouvelle poisition
     INewCurseur := ( X - 0 ) div StringGrid.DefaultColWidth;
     if INewCurseur < 0 then INewCurseur := 0 else
     if INewCurseur > 6 then INewCurseur := 6;
     // effacement position prcdente
     if INewCurseur <> Plateau.ICurseur then
       if Timer.Enabled and ( Timer.Tag = 1 ) then
         begin
         TimerTimer( nil );
         Plateau.ICurseur := INewCurseur;
         TimerTimer( Self );
         end;
     Plateau.ICurseur := INewCurseur;
     
end;

procedure TFMain.StringGridMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
     if ( Now - DDernierLache ) < ( 0.1 / ( 3600 * 24 ) ) then Exit; // pour viter le multi lachs involontaire
     if Plateau.IJoueur = 0 then Exit; // pas en cours de jeu
     Plateau.Jouer;
     DDernierLache := Now;
end;


end.
